package controladores;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
import Logica.Factory;
import Logica.ISistema;
import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.util.Base64;

/**
 *
 * @author pecaa
 */
@WebServlet(name = "login", urlPatterns = {"/login"})
public class login extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        /* Atiende las llamadas por get (las llamadas del navegador) */
        HttpSession session = request.getSession();
        if (session.getAttribute("userName") != null){
            response.sendRedirect(request.getContextPath());
        }else{
            response.setContentType("text/html;charset=UTF-8");
            RequestDispatcher dispatsh = request.getRequestDispatcher("page/login/login.jsp");
            dispatsh.forward(request, response);
        }
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        /* Preparo respuesta */ 
        String respuesta = "Error";
        
        String metodo = getParameter(request,"metodo");
        switch(metodo){
            case "logout":
                respuesta = logout(request);
                break;
            case "login":
                respuesta = login(request);
                break;
            default:
                respuesta = "Metodo invalido";
        }
        /* respondo */
        response.setContentType("text/plain");
        response.getWriter().write(respuesta);
        
        
        
        

    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Responde peticiones echas a la resepcion de datos";
    }

    /* Funciopnes propias ----------------------------------------------------*/
    /*------------------------------------------------------------------------*/
    
    /**
     * GetParameter retorna el parametro de existir en request
     * 
     * @param request type HttpServletRequest -> request de la peticion
     * @param text type String -> parametro que desea buscar
     * @return parametro type String -> retorna valor de parametro o null de no 
     * encontrarlo
     * 
     */
    private String getParameter(HttpServletRequest request,String text){
        String parametro = request.getParameter(text);
        if (parametro != null){
            parametro = parametro.trim();
        }
        return parametro;
    }
    
 
    /* Funciopnes de metodos -------------------------------------------------*/
    /*------------------------------------------------------------------------*/   
    
    /**
     * logout metodo llamado por ajax, remuebe datos de sesion
     * 
     * @param request type HttpServletRequest -> request donde elimina datos de 
     * sesion
     * @return String con mensaje de estado
     * 
     */
    private String logout(HttpServletRequest request){
        HttpSession s = request.getSession();
        s.removeAttribute("userName");
        s.removeAttribute("imgUser");
        return "exito";
    } 
    
    /**
     * login metodo llamado por ajax, confima datos, verifica existencia y 
     * retorna estado
     * 
     * @param request type HttpServletRequest -> request donde guardara datos de 
     * sesion
     * @return String con mensaje de estado
     * 
     */
    private String login(HttpServletRequest request){
        String userName = getParameter(request,"userName");
        String userPass = getParameter(request,"userPass");
        Logica.datatype.DtUsuario u = null;
        if (userName == null || "".equals(userName)){
            return "Contraseña es nesecaria";
        }else if ( userPass == null || "".equals(userPass)) {
            return "Nick es nesecario";
        } else {
            ISistema sys = null;
            sys = Factory.getInstance();
            if (sys.existeUserConPass(userName, userPass)){
                u = sys.getUser(userName);
                if (u != null){
                    HttpSession s = request.getSession();
                    s.setAttribute("userName", u.getNick());
                    s.setAttribute("userPass", u.getPass());
                    s.setAttribute("userType", u.getType());
                    if (u.getImg() != null){
                        s.setAttribute("imgUser", Base64.getEncoder().encodeToString(u.getImg()) );
                    }
                    return "exito";
                }else{
                    return "Error no esperado.";
                }
            }
            else{
                return "El usuario no existe";
            }
        }
    }
    
    
    
    
    private void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {


        response.setContentType("text/html;charset=UTF-8");
        RequestDispatcher dispatsh = request.getRequestDispatcher("page/login/login.jsp");
        dispatsh.forward(request, response);
    }

}
