$(document).ready(function () {
    $('#btn-login').click(function () {
        funcionLogin();
    });
    
    $('#loginNick').keyup(function (e) {
        if (e.keyCode == 13) {
            funcionLogin();
        }
    });
    
    $('#loginPass').keyup(function (e) {
        if (e.keyCode == 13) {
            funcionLogin();
        }
    });

    $('#btn-logout').click(function () {
        funcionLogout();
    });
    
    $('#btn-extender').click(function () {
        let propuesta   = $(this).prop("data-user");
        funcionExtenderFinanciación(propuesta);
    });
    
    $('#btn-cancelar').click(function () {
        let propuesta   = $(this).prop("data-user");
        funcionCancelarPropuesta(propuesta)
    });
    
    $('.btn-Seguir').click(function () {
        let user   = $(this).attr("data-user");
        funcionSeguirUsuario(user);
    });
    
    $('.btn-desSeguir').click(function () {
        event.preventDefault();
        let user   = $(this).attr("data-user");
        funcionDejarSeguirUsuario(user);
    });
    
    $('.btn-like').click(function () {
        event.preventDefault();
        let titulo   = $(this).attr("data-titulo");
        funcionPropuestaFavorita(titulo);
    });

     $('#btn-new-user').click(function () {
        funcionAltaPerfil();
     });
     
     $('#btn-new-propuesta').click(function () {
        funcionAltaPropuesta();
     });
     
     $('.btn-send').click(function () {
        event.preventDefault();
        let prop   = $(this).attr("data-prop");
        let msg      = $("#feed-msg").val();
        funcionComentario(prop,msg);
     });

    $("#img").change(function () {
        if (this.files && this.files[0]) {
            var reader = new FileReader();
            reader.onload = function (e) {
                $('#img-prev').attr('src', e.target.result);
            }
            reader.readAsDataURL(this.files[0]);
        }
    });

});
function  funcionMandaFormulario(type, url, cadena, success,error) {
    $.ajax({
        url: url,
        type: type,
        data: cadena,
        beforeSend: function () {
            cargar(true);
        },
        success: function (responseText) {
            alert(responseText);
            cargar(false);
            success();
        },
        error: function (jqXHR, textStatus) {
            alert(textStatus);
            cargar(false);
            error();
        }
    });
}

/* Alta de Perfil ------------------------------------------------------------*/
function  funcionAltaPerfil() {
    event.preventDefault();
    var type = "POST";
    var url = 'user';
    var cadena = $(".form-usuario").serialize();
    funcionMandaFormulario(type, url, cadena);
}
/* Cierre de Sesión ----------------------------------------------------------*/
function  funcionLogout() {
    $.ajax({
        url: 'login',
        type: 'POST',
        data: {
            metodo: "logout",
            salir: true,
        },
        beforeSend: function () {
            cargar(true);
        },
        success: function (responseText) {
            window.location.href = window.location.origin + "/g4/login";
        },
        error: function (jqXHR, textStatus) {
            alert(textStatus);
            cargar(false);
        }
    });
}
/* Inicio de Sesión ----------------------------------------------------------*/
function  funcionLogin() {
    if ($('#loginNick').val() == "") {
        alert("Falta el nick");
    } else if ($('#loginPass').val() == "") {
        alert("Falta el password");
    } else {
        $.ajax({
            url: 'login',
            type: 'POST',
            data: {
                metodo: "login",
                userName: $('#loginNick').val(),
                userPass: $('#loginPass').val()
            },
            beforeSend: function () {
                cargar(true);
            },
            success: function (responseText) {
                console.log(responseText);
                if (responseText == "exito") {
                    window.location.href = window.location.origin + "/g4";
                } else {
                    alert(responseText);
                    cargar(false);
                }
            },
            error: function (jqXHR, textStatus) {
                alert(textStatus);
                cargar(false);
            }
        });
    }
}
/* Alta de Propuesta ---------------------------------------------------------*/
function funcionAltaPropuesta() {
    event.preventDefault();
    var type = "POST";
    var url = 'propuesta';
    var cadena = $(".form-usuario").serialize();
    funcionMandaFormulario(type, url, cadena);
}
/* Registrar Colaboración a Propuesta ----------------------------------------*/
function funcionRegistrarColaboración() {
    var type = "POST";
    var url = 'colaboracion';
    var data = { 
        monto:$("#monto").val(),
        porsentaje:document.getElementById('porsentaje').checked,
        entrada:document.getElementById('entrada').checked,
        metodo: "colaboracion"
    };
    funcionMandaFormulario(type, url, data);
}
/* Extender Financiación -----------------------------------------------------*/
function funcionExtenderFinanciación( propuesta) {
    $.ajax({
        url: 'propuesta',
        type: 'POST',
        data: {
            metodo: "ExtenderFinanciación",
            propuestaId: propuesta
        },
        beforeSend: function () {
            cargar(true);
        },
        success: function (responseText) {
            console.log(responseText);
            if (responseText == "exito") {
                window.location.href = window.location.origin + "/g4";
            } else {
                alert(textStatus);
                cargar(false);
            }
        },
        error: function (jqXHR, textStatus) {
            alert(textStatus);
            cargar(false);
        }
    });

}
/* Cancelar Propuesta --------------------------------------------------------*/
function funcionCancelarPropuesta(propuesta) {
    $.ajax({
        url: 'propuesta',
        type: 'POST',
        data: {
            metodo: "CancelarPropuesta",
            propuestaId: propuesta
        },
        beforeSend: function () {
            cargar(true);
        },
        success: function (responseText) {
            cargar(false);
            alert(responseText);
        },
        error: function (jqXHR, textStatus) {
            alert(textStatus);
            cargar(false);
        }
    });
}
/* Agregar Comentario a Propuesta --------------------------------------------*/
function funcionComentario(propuesta,text) {
    $.ajax({
        url: 'propuesta',
        type: 'POST',
        data: {
            metodo: "Comentario",
            propuestaId: propuesta,
            text:text
        },
        beforeSend: function () {
            cargar(true);
        },
        success: function (responseText) {
            cargar(false);
            alert(responseText);
        },
        error: function (jqXHR, textStatus) {
            alert(textStatus);
            cargar(false);
        }
    });
}
/* Consulta de Propuesta por Categoría ---------------------------------------*/
function funcionPropuestaCategoría(Categoría) {
    $.ajax({
        url: 'propuesta',
        type: 'POST',
        data: {
            metodo: "PropuestaCategoría",
            Categoría: Categoría
        },
        beforeSend: function () {
            cargar(true);
        },
        success: function (responseText) {
            
            
            
            
            
        },
        error: function (jqXHR, textStatus) {
            alert(textStatus);
            cargar(false);
        }
    });
}
/* Seguir Usuario ------------------------------------------------------------*/
function funcionSeguirUsuario(asegido) {
    $.ajax({
        url: 'user',
        type: 'POST',
        data: {
            metodo: "SeguirUsuario",
            asegido: asegido
        },
        beforeSend: function () {
            cargar(true);
        },
        success: function (responseText) {
            cargar(false);
            alert(responseText);
        },
        error: function (jqXHR, textStatus) {
            alert(textStatus);
            cargar(false);
        }
    });
}
/* Dejar de Seguir Usuario ---------------------------------------------------*/
function funcionDejarSeguirUsuario(asegido) {
        $.ajax({
        url: 'user',
        type: 'POST',
        data: {
            metodo: "DejarSeguirUsuario",
            asegido: asegido
        },
        beforeSend: function () {
            cargar(true);
        },
        success: function (responseText) {
            cargar(false);
            alert(responseText);
        },
        error: function (jqXHR, textStatus) {
            cargar(false);
            alert(textStatus);
        }
    });
}
/* Marcar Propuesta como Favorita --------------------------------------------*/
function funcionPropuestaFavorita(propuesta) {
        $.ajax({
        url: 'user',
        type: 'POST',
        data: {
            metodo: "Favorita",
            propuesta: propuesta,
        },
        beforeSend: function () {
            cargar(true);
        },
        success: function (responseText) {
            cargar(false);
            alert(responseText);
        },
        error: function (jqXHR, textStatus) {
            cargar(false);
            alert(textStatus);
        }
    });
}